// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: essmodule/essmodule.proto

package openfmb.essmodule;

/**
 * <pre>
 * ESS inverter high level function to shut down ESS if SOC exceeds high or low limits.
 * </pre>
 *
 * Protobuf type {@code essmodule.SocLimit}
 */
public final class SocLimit extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:essmodule.SocLimit)
    SocLimitOrBuilder {
private static final long serialVersionUID = 0L;
  // Use SocLimit.newBuilder() to construct.
  private SocLimit(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private SocLimit() {
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(
      UnusedPrivateParameter unused) {
    return new SocLimit();
  }

  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return openfmb.essmodule.Essmodule.internal_static_essmodule_SocLimit_descriptor;
  }

  @java.lang.Override
  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return openfmb.essmodule.Essmodule.internal_static_essmodule_SocLimit_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            openfmb.essmodule.SocLimit.class, openfmb.essmodule.SocLimit.Builder.class);
  }

  public static final int SOCHIGHLIMIT_FIELD_NUMBER = 1;
  private com.google.protobuf.FloatValue socHighLimit_;
  /**
   * <pre>
   * uint/1%  These limits define the operational range of the battery. If a lineup reaches the SOC
   * high limit, the inverter’s output is reduced to 0. Charging is then blocked until the hysteresis is
   * overcome. The same logic applies to the SOC low limit, except that after the ramp down is complete,
   * discharging is blocked until the hysteresis is overcome.
   * </pre>
   *
   * <code>.google.protobuf.FloatValue socHighLimit = 1;</code>
   * @return Whether the socHighLimit field is set.
   */
  @java.lang.Override
  public boolean hasSocHighLimit() {
    return socHighLimit_ != null;
  }
  /**
   * <pre>
   * uint/1%  These limits define the operational range of the battery. If a lineup reaches the SOC
   * high limit, the inverter’s output is reduced to 0. Charging is then blocked until the hysteresis is
   * overcome. The same logic applies to the SOC low limit, except that after the ramp down is complete,
   * discharging is blocked until the hysteresis is overcome.
   * </pre>
   *
   * <code>.google.protobuf.FloatValue socHighLimit = 1;</code>
   * @return The socHighLimit.
   */
  @java.lang.Override
  public com.google.protobuf.FloatValue getSocHighLimit() {
    return socHighLimit_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : socHighLimit_;
  }
  /**
   * <pre>
   * uint/1%  These limits define the operational range of the battery. If a lineup reaches the SOC
   * high limit, the inverter’s output is reduced to 0. Charging is then blocked until the hysteresis is
   * overcome. The same logic applies to the SOC low limit, except that after the ramp down is complete,
   * discharging is blocked until the hysteresis is overcome.
   * </pre>
   *
   * <code>.google.protobuf.FloatValue socHighLimit = 1;</code>
   */
  @java.lang.Override
  public com.google.protobuf.FloatValueOrBuilder getSocHighLimitOrBuilder() {
    return socHighLimit_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : socHighLimit_;
  }

  public static final int SOCHIGHLIMITHYSTERESIS_FIELD_NUMBER = 2;
  private com.google.protobuf.FloatValue socHighLimitHysteresis_;
  /**
   * <pre>
   * uint/1%  These limits define the operational range of the battery. If a lineup reaches the SOC
   * high limit, the inverter’s output is reduced to 0. Charging is then blocked until the hysteresis is
   * overcome. The same logic applies to the SOC low limit, except that after the ramp down is complete,
   * discharging is blocked until the hysteresis is overcome.
   * </pre>
   *
   * <code>.google.protobuf.FloatValue socHighLimitHysteresis = 2;</code>
   * @return Whether the socHighLimitHysteresis field is set.
   */
  @java.lang.Override
  public boolean hasSocHighLimitHysteresis() {
    return socHighLimitHysteresis_ != null;
  }
  /**
   * <pre>
   * uint/1%  These limits define the operational range of the battery. If a lineup reaches the SOC
   * high limit, the inverter’s output is reduced to 0. Charging is then blocked until the hysteresis is
   * overcome. The same logic applies to the SOC low limit, except that after the ramp down is complete,
   * discharging is blocked until the hysteresis is overcome.
   * </pre>
   *
   * <code>.google.protobuf.FloatValue socHighLimitHysteresis = 2;</code>
   * @return The socHighLimitHysteresis.
   */
  @java.lang.Override
  public com.google.protobuf.FloatValue getSocHighLimitHysteresis() {
    return socHighLimitHysteresis_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : socHighLimitHysteresis_;
  }
  /**
   * <pre>
   * uint/1%  These limits define the operational range of the battery. If a lineup reaches the SOC
   * high limit, the inverter’s output is reduced to 0. Charging is then blocked until the hysteresis is
   * overcome. The same logic applies to the SOC low limit, except that after the ramp down is complete,
   * discharging is blocked until the hysteresis is overcome.
   * </pre>
   *
   * <code>.google.protobuf.FloatValue socHighLimitHysteresis = 2;</code>
   */
  @java.lang.Override
  public com.google.protobuf.FloatValueOrBuilder getSocHighLimitHysteresisOrBuilder() {
    return socHighLimitHysteresis_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : socHighLimitHysteresis_;
  }

  public static final int SOCLIMITCTL_FIELD_NUMBER = 3;
  private com.google.protobuf.BoolValue socLimitCtl_;
  /**
   * <pre>
   * Control value (TRUE or FALSE)
   * </pre>
   *
   * <code>.google.protobuf.BoolValue socLimitCtl = 3;</code>
   * @return Whether the socLimitCtl field is set.
   */
  @java.lang.Override
  public boolean hasSocLimitCtl() {
    return socLimitCtl_ != null;
  }
  /**
   * <pre>
   * Control value (TRUE or FALSE)
   * </pre>
   *
   * <code>.google.protobuf.BoolValue socLimitCtl = 3;</code>
   * @return The socLimitCtl.
   */
  @java.lang.Override
  public com.google.protobuf.BoolValue getSocLimitCtl() {
    return socLimitCtl_ == null ? com.google.protobuf.BoolValue.getDefaultInstance() : socLimitCtl_;
  }
  /**
   * <pre>
   * Control value (TRUE or FALSE)
   * </pre>
   *
   * <code>.google.protobuf.BoolValue socLimitCtl = 3;</code>
   */
  @java.lang.Override
  public com.google.protobuf.BoolValueOrBuilder getSocLimitCtlOrBuilder() {
    return socLimitCtl_ == null ? com.google.protobuf.BoolValue.getDefaultInstance() : socLimitCtl_;
  }

  public static final int SOCLOWLIMIT_FIELD_NUMBER = 4;
  private com.google.protobuf.FloatValue socLowLimit_;
  /**
   * <pre>
   * uint/1%  These limits define the operational range of the battery. If a lineup reaches the SOC
   * high limit, the inverter’s output is reduced to 0. Charging is then blocked until the hysteresis is
   * overcome. The same logic applies to the SOC low limit, except that after the ramp down is complete,
   * discharging is blocked until the hysteresis is overcome.
   * </pre>
   *
   * <code>.google.protobuf.FloatValue socLowLimit = 4;</code>
   * @return Whether the socLowLimit field is set.
   */
  @java.lang.Override
  public boolean hasSocLowLimit() {
    return socLowLimit_ != null;
  }
  /**
   * <pre>
   * uint/1%  These limits define the operational range of the battery. If a lineup reaches the SOC
   * high limit, the inverter’s output is reduced to 0. Charging is then blocked until the hysteresis is
   * overcome. The same logic applies to the SOC low limit, except that after the ramp down is complete,
   * discharging is blocked until the hysteresis is overcome.
   * </pre>
   *
   * <code>.google.protobuf.FloatValue socLowLimit = 4;</code>
   * @return The socLowLimit.
   */
  @java.lang.Override
  public com.google.protobuf.FloatValue getSocLowLimit() {
    return socLowLimit_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : socLowLimit_;
  }
  /**
   * <pre>
   * uint/1%  These limits define the operational range of the battery. If a lineup reaches the SOC
   * high limit, the inverter’s output is reduced to 0. Charging is then blocked until the hysteresis is
   * overcome. The same logic applies to the SOC low limit, except that after the ramp down is complete,
   * discharging is blocked until the hysteresis is overcome.
   * </pre>
   *
   * <code>.google.protobuf.FloatValue socLowLimit = 4;</code>
   */
  @java.lang.Override
  public com.google.protobuf.FloatValueOrBuilder getSocLowLimitOrBuilder() {
    return socLowLimit_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : socLowLimit_;
  }

  public static final int SOCLOWLIMITHYSTERESIS_FIELD_NUMBER = 5;
  private com.google.protobuf.FloatValue socLowLimitHysteresis_;
  /**
   * <pre>
   * uint/1%  These hysteresis define the release conditions for the block charge or discharge
   * initiated by the SOC limits.For example, assume a SOC low limit of 10% and a SOC low limit
   * hysteresis of 2% and that discharging is blocked because the batteries SOC reached the SOC low
   * limit, discharging will only be allowed again after the battery’s SOC reaches 13%.
   * </pre>
   *
   * <code>.google.protobuf.FloatValue socLowLimitHysteresis = 5;</code>
   * @return Whether the socLowLimitHysteresis field is set.
   */
  @java.lang.Override
  public boolean hasSocLowLimitHysteresis() {
    return socLowLimitHysteresis_ != null;
  }
  /**
   * <pre>
   * uint/1%  These hysteresis define the release conditions for the block charge or discharge
   * initiated by the SOC limits.For example, assume a SOC low limit of 10% and a SOC low limit
   * hysteresis of 2% and that discharging is blocked because the batteries SOC reached the SOC low
   * limit, discharging will only be allowed again after the battery’s SOC reaches 13%.
   * </pre>
   *
   * <code>.google.protobuf.FloatValue socLowLimitHysteresis = 5;</code>
   * @return The socLowLimitHysteresis.
   */
  @java.lang.Override
  public com.google.protobuf.FloatValue getSocLowLimitHysteresis() {
    return socLowLimitHysteresis_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : socLowLimitHysteresis_;
  }
  /**
   * <pre>
   * uint/1%  These hysteresis define the release conditions for the block charge or discharge
   * initiated by the SOC limits.For example, assume a SOC low limit of 10% and a SOC low limit
   * hysteresis of 2% and that discharging is blocked because the batteries SOC reached the SOC low
   * limit, discharging will only be allowed again after the battery’s SOC reaches 13%.
   * </pre>
   *
   * <code>.google.protobuf.FloatValue socLowLimitHysteresis = 5;</code>
   */
  @java.lang.Override
  public com.google.protobuf.FloatValueOrBuilder getSocLowLimitHysteresisOrBuilder() {
    return socLowLimitHysteresis_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : socLowLimitHysteresis_;
  }

  private byte memoizedIsInitialized = -1;
  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (socHighLimit_ != null) {
      output.writeMessage(1, getSocHighLimit());
    }
    if (socHighLimitHysteresis_ != null) {
      output.writeMessage(2, getSocHighLimitHysteresis());
    }
    if (socLimitCtl_ != null) {
      output.writeMessage(3, getSocLimitCtl());
    }
    if (socLowLimit_ != null) {
      output.writeMessage(4, getSocLowLimit());
    }
    if (socLowLimitHysteresis_ != null) {
      output.writeMessage(5, getSocLowLimitHysteresis());
    }
    getUnknownFields().writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (socHighLimit_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(1, getSocHighLimit());
    }
    if (socHighLimitHysteresis_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(2, getSocHighLimitHysteresis());
    }
    if (socLimitCtl_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(3, getSocLimitCtl());
    }
    if (socLowLimit_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(4, getSocLowLimit());
    }
    if (socLowLimitHysteresis_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(5, getSocLowLimitHysteresis());
    }
    size += getUnknownFields().getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof openfmb.essmodule.SocLimit)) {
      return super.equals(obj);
    }
    openfmb.essmodule.SocLimit other = (openfmb.essmodule.SocLimit) obj;

    if (hasSocHighLimit() != other.hasSocHighLimit()) return false;
    if (hasSocHighLimit()) {
      if (!getSocHighLimit()
          .equals(other.getSocHighLimit())) return false;
    }
    if (hasSocHighLimitHysteresis() != other.hasSocHighLimitHysteresis()) return false;
    if (hasSocHighLimitHysteresis()) {
      if (!getSocHighLimitHysteresis()
          .equals(other.getSocHighLimitHysteresis())) return false;
    }
    if (hasSocLimitCtl() != other.hasSocLimitCtl()) return false;
    if (hasSocLimitCtl()) {
      if (!getSocLimitCtl()
          .equals(other.getSocLimitCtl())) return false;
    }
    if (hasSocLowLimit() != other.hasSocLowLimit()) return false;
    if (hasSocLowLimit()) {
      if (!getSocLowLimit()
          .equals(other.getSocLowLimit())) return false;
    }
    if (hasSocLowLimitHysteresis() != other.hasSocLowLimitHysteresis()) return false;
    if (hasSocLowLimitHysteresis()) {
      if (!getSocLowLimitHysteresis()
          .equals(other.getSocLowLimitHysteresis())) return false;
    }
    if (!getUnknownFields().equals(other.getUnknownFields())) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (hasSocHighLimit()) {
      hash = (37 * hash) + SOCHIGHLIMIT_FIELD_NUMBER;
      hash = (53 * hash) + getSocHighLimit().hashCode();
    }
    if (hasSocHighLimitHysteresis()) {
      hash = (37 * hash) + SOCHIGHLIMITHYSTERESIS_FIELD_NUMBER;
      hash = (53 * hash) + getSocHighLimitHysteresis().hashCode();
    }
    if (hasSocLimitCtl()) {
      hash = (37 * hash) + SOCLIMITCTL_FIELD_NUMBER;
      hash = (53 * hash) + getSocLimitCtl().hashCode();
    }
    if (hasSocLowLimit()) {
      hash = (37 * hash) + SOCLOWLIMIT_FIELD_NUMBER;
      hash = (53 * hash) + getSocLowLimit().hashCode();
    }
    if (hasSocLowLimitHysteresis()) {
      hash = (37 * hash) + SOCLOWLIMITHYSTERESIS_FIELD_NUMBER;
      hash = (53 * hash) + getSocLowLimitHysteresis().hashCode();
    }
    hash = (29 * hash) + getUnknownFields().hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static openfmb.essmodule.SocLimit parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.essmodule.SocLimit parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.essmodule.SocLimit parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.essmodule.SocLimit parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.essmodule.SocLimit parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.essmodule.SocLimit parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.essmodule.SocLimit parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.essmodule.SocLimit parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.essmodule.SocLimit parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static openfmb.essmodule.SocLimit parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.essmodule.SocLimit parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.essmodule.SocLimit parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(openfmb.essmodule.SocLimit prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * <pre>
   * ESS inverter high level function to shut down ESS if SOC exceeds high or low limits.
   * </pre>
   *
   * Protobuf type {@code essmodule.SocLimit}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:essmodule.SocLimit)
      openfmb.essmodule.SocLimitOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return openfmb.essmodule.Essmodule.internal_static_essmodule_SocLimit_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return openfmb.essmodule.Essmodule.internal_static_essmodule_SocLimit_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              openfmb.essmodule.SocLimit.class, openfmb.essmodule.SocLimit.Builder.class);
    }

    // Construct using openfmb.essmodule.SocLimit.newBuilder()
    private Builder() {

    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);

    }
    @java.lang.Override
    public Builder clear() {
      super.clear();
      bitField0_ = 0;
      socHighLimit_ = null;
      if (socHighLimitBuilder_ != null) {
        socHighLimitBuilder_.dispose();
        socHighLimitBuilder_ = null;
      }
      socHighLimitHysteresis_ = null;
      if (socHighLimitHysteresisBuilder_ != null) {
        socHighLimitHysteresisBuilder_.dispose();
        socHighLimitHysteresisBuilder_ = null;
      }
      socLimitCtl_ = null;
      if (socLimitCtlBuilder_ != null) {
        socLimitCtlBuilder_.dispose();
        socLimitCtlBuilder_ = null;
      }
      socLowLimit_ = null;
      if (socLowLimitBuilder_ != null) {
        socLowLimitBuilder_.dispose();
        socLowLimitBuilder_ = null;
      }
      socLowLimitHysteresis_ = null;
      if (socLowLimitHysteresisBuilder_ != null) {
        socLowLimitHysteresisBuilder_.dispose();
        socLowLimitHysteresisBuilder_ = null;
      }
      return this;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return openfmb.essmodule.Essmodule.internal_static_essmodule_SocLimit_descriptor;
    }

    @java.lang.Override
    public openfmb.essmodule.SocLimit getDefaultInstanceForType() {
      return openfmb.essmodule.SocLimit.getDefaultInstance();
    }

    @java.lang.Override
    public openfmb.essmodule.SocLimit build() {
      openfmb.essmodule.SocLimit result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public openfmb.essmodule.SocLimit buildPartial() {
      openfmb.essmodule.SocLimit result = new openfmb.essmodule.SocLimit(this);
      if (bitField0_ != 0) { buildPartial0(result); }
      onBuilt();
      return result;
    }

    private void buildPartial0(openfmb.essmodule.SocLimit result) {
      int from_bitField0_ = bitField0_;
      if (((from_bitField0_ & 0x00000001) != 0)) {
        result.socHighLimit_ = socHighLimitBuilder_ == null
            ? socHighLimit_
            : socHighLimitBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000002) != 0)) {
        result.socHighLimitHysteresis_ = socHighLimitHysteresisBuilder_ == null
            ? socHighLimitHysteresis_
            : socHighLimitHysteresisBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000004) != 0)) {
        result.socLimitCtl_ = socLimitCtlBuilder_ == null
            ? socLimitCtl_
            : socLimitCtlBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000008) != 0)) {
        result.socLowLimit_ = socLowLimitBuilder_ == null
            ? socLowLimit_
            : socLowLimitBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000010) != 0)) {
        result.socLowLimitHysteresis_ = socLowLimitHysteresisBuilder_ == null
            ? socLowLimitHysteresis_
            : socLowLimitHysteresisBuilder_.build();
      }
    }

    @java.lang.Override
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof openfmb.essmodule.SocLimit) {
        return mergeFrom((openfmb.essmodule.SocLimit)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(openfmb.essmodule.SocLimit other) {
      if (other == openfmb.essmodule.SocLimit.getDefaultInstance()) return this;
      if (other.hasSocHighLimit()) {
        mergeSocHighLimit(other.getSocHighLimit());
      }
      if (other.hasSocHighLimitHysteresis()) {
        mergeSocHighLimitHysteresis(other.getSocHighLimitHysteresis());
      }
      if (other.hasSocLimitCtl()) {
        mergeSocLimitCtl(other.getSocLimitCtl());
      }
      if (other.hasSocLowLimit()) {
        mergeSocLowLimit(other.getSocLowLimit());
      }
      if (other.hasSocLowLimitHysteresis()) {
        mergeSocLowLimitHysteresis(other.getSocLowLimitHysteresis());
      }
      this.mergeUnknownFields(other.getUnknownFields());
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              input.readMessage(
                  getSocHighLimitFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000001;
              break;
            } // case 10
            case 18: {
              input.readMessage(
                  getSocHighLimitHysteresisFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000002;
              break;
            } // case 18
            case 26: {
              input.readMessage(
                  getSocLimitCtlFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000004;
              break;
            } // case 26
            case 34: {
              input.readMessage(
                  getSocLowLimitFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000008;
              break;
            } // case 34
            case 42: {
              input.readMessage(
                  getSocLowLimitHysteresisFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000010;
              break;
            } // case 42
            default: {
              if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                done = true; // was an endgroup tag
              }
              break;
            } // default:
          } // switch (tag)
        } // while (!done)
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.unwrapIOException();
      } finally {
        onChanged();
      } // finally
      return this;
    }
    private int bitField0_;

    private com.google.protobuf.FloatValue socHighLimit_;
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder> socHighLimitBuilder_;
    /**
     * <pre>
     * uint/1%  These limits define the operational range of the battery. If a lineup reaches the SOC
     * high limit, the inverter’s output is reduced to 0. Charging is then blocked until the hysteresis is
     * overcome. The same logic applies to the SOC low limit, except that after the ramp down is complete,
     * discharging is blocked until the hysteresis is overcome.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue socHighLimit = 1;</code>
     * @return Whether the socHighLimit field is set.
     */
    public boolean hasSocHighLimit() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     * <pre>
     * uint/1%  These limits define the operational range of the battery. If a lineup reaches the SOC
     * high limit, the inverter’s output is reduced to 0. Charging is then blocked until the hysteresis is
     * overcome. The same logic applies to the SOC low limit, except that after the ramp down is complete,
     * discharging is blocked until the hysteresis is overcome.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue socHighLimit = 1;</code>
     * @return The socHighLimit.
     */
    public com.google.protobuf.FloatValue getSocHighLimit() {
      if (socHighLimitBuilder_ == null) {
        return socHighLimit_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : socHighLimit_;
      } else {
        return socHighLimitBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * uint/1%  These limits define the operational range of the battery. If a lineup reaches the SOC
     * high limit, the inverter’s output is reduced to 0. Charging is then blocked until the hysteresis is
     * overcome. The same logic applies to the SOC low limit, except that after the ramp down is complete,
     * discharging is blocked until the hysteresis is overcome.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue socHighLimit = 1;</code>
     */
    public Builder setSocHighLimit(com.google.protobuf.FloatValue value) {
      if (socHighLimitBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        socHighLimit_ = value;
      } else {
        socHighLimitBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/1%  These limits define the operational range of the battery. If a lineup reaches the SOC
     * high limit, the inverter’s output is reduced to 0. Charging is then blocked until the hysteresis is
     * overcome. The same logic applies to the SOC low limit, except that after the ramp down is complete,
     * discharging is blocked until the hysteresis is overcome.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue socHighLimit = 1;</code>
     */
    public Builder setSocHighLimit(
        com.google.protobuf.FloatValue.Builder builderForValue) {
      if (socHighLimitBuilder_ == null) {
        socHighLimit_ = builderForValue.build();
      } else {
        socHighLimitBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/1%  These limits define the operational range of the battery. If a lineup reaches the SOC
     * high limit, the inverter’s output is reduced to 0. Charging is then blocked until the hysteresis is
     * overcome. The same logic applies to the SOC low limit, except that after the ramp down is complete,
     * discharging is blocked until the hysteresis is overcome.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue socHighLimit = 1;</code>
     */
    public Builder mergeSocHighLimit(com.google.protobuf.FloatValue value) {
      if (socHighLimitBuilder_ == null) {
        if (((bitField0_ & 0x00000001) != 0) &&
          socHighLimit_ != null &&
          socHighLimit_ != com.google.protobuf.FloatValue.getDefaultInstance()) {
          getSocHighLimitBuilder().mergeFrom(value);
        } else {
          socHighLimit_ = value;
        }
      } else {
        socHighLimitBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/1%  These limits define the operational range of the battery. If a lineup reaches the SOC
     * high limit, the inverter’s output is reduced to 0. Charging is then blocked until the hysteresis is
     * overcome. The same logic applies to the SOC low limit, except that after the ramp down is complete,
     * discharging is blocked until the hysteresis is overcome.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue socHighLimit = 1;</code>
     */
    public Builder clearSocHighLimit() {
      bitField0_ = (bitField0_ & ~0x00000001);
      socHighLimit_ = null;
      if (socHighLimitBuilder_ != null) {
        socHighLimitBuilder_.dispose();
        socHighLimitBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/1%  These limits define the operational range of the battery. If a lineup reaches the SOC
     * high limit, the inverter’s output is reduced to 0. Charging is then blocked until the hysteresis is
     * overcome. The same logic applies to the SOC low limit, except that after the ramp down is complete,
     * discharging is blocked until the hysteresis is overcome.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue socHighLimit = 1;</code>
     */
    public com.google.protobuf.FloatValue.Builder getSocHighLimitBuilder() {
      bitField0_ |= 0x00000001;
      onChanged();
      return getSocHighLimitFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * uint/1%  These limits define the operational range of the battery. If a lineup reaches the SOC
     * high limit, the inverter’s output is reduced to 0. Charging is then blocked until the hysteresis is
     * overcome. The same logic applies to the SOC low limit, except that after the ramp down is complete,
     * discharging is blocked until the hysteresis is overcome.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue socHighLimit = 1;</code>
     */
    public com.google.protobuf.FloatValueOrBuilder getSocHighLimitOrBuilder() {
      if (socHighLimitBuilder_ != null) {
        return socHighLimitBuilder_.getMessageOrBuilder();
      } else {
        return socHighLimit_ == null ?
            com.google.protobuf.FloatValue.getDefaultInstance() : socHighLimit_;
      }
    }
    /**
     * <pre>
     * uint/1%  These limits define the operational range of the battery. If a lineup reaches the SOC
     * high limit, the inverter’s output is reduced to 0. Charging is then blocked until the hysteresis is
     * overcome. The same logic applies to the SOC low limit, except that after the ramp down is complete,
     * discharging is blocked until the hysteresis is overcome.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue socHighLimit = 1;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder> 
        getSocHighLimitFieldBuilder() {
      if (socHighLimitBuilder_ == null) {
        socHighLimitBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder>(
                getSocHighLimit(),
                getParentForChildren(),
                isClean());
        socHighLimit_ = null;
      }
      return socHighLimitBuilder_;
    }

    private com.google.protobuf.FloatValue socHighLimitHysteresis_;
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder> socHighLimitHysteresisBuilder_;
    /**
     * <pre>
     * uint/1%  These limits define the operational range of the battery. If a lineup reaches the SOC
     * high limit, the inverter’s output is reduced to 0. Charging is then blocked until the hysteresis is
     * overcome. The same logic applies to the SOC low limit, except that after the ramp down is complete,
     * discharging is blocked until the hysteresis is overcome.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue socHighLimitHysteresis = 2;</code>
     * @return Whether the socHighLimitHysteresis field is set.
     */
    public boolean hasSocHighLimitHysteresis() {
      return ((bitField0_ & 0x00000002) != 0);
    }
    /**
     * <pre>
     * uint/1%  These limits define the operational range of the battery. If a lineup reaches the SOC
     * high limit, the inverter’s output is reduced to 0. Charging is then blocked until the hysteresis is
     * overcome. The same logic applies to the SOC low limit, except that after the ramp down is complete,
     * discharging is blocked until the hysteresis is overcome.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue socHighLimitHysteresis = 2;</code>
     * @return The socHighLimitHysteresis.
     */
    public com.google.protobuf.FloatValue getSocHighLimitHysteresis() {
      if (socHighLimitHysteresisBuilder_ == null) {
        return socHighLimitHysteresis_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : socHighLimitHysteresis_;
      } else {
        return socHighLimitHysteresisBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * uint/1%  These limits define the operational range of the battery. If a lineup reaches the SOC
     * high limit, the inverter’s output is reduced to 0. Charging is then blocked until the hysteresis is
     * overcome. The same logic applies to the SOC low limit, except that after the ramp down is complete,
     * discharging is blocked until the hysteresis is overcome.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue socHighLimitHysteresis = 2;</code>
     */
    public Builder setSocHighLimitHysteresis(com.google.protobuf.FloatValue value) {
      if (socHighLimitHysteresisBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        socHighLimitHysteresis_ = value;
      } else {
        socHighLimitHysteresisBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/1%  These limits define the operational range of the battery. If a lineup reaches the SOC
     * high limit, the inverter’s output is reduced to 0. Charging is then blocked until the hysteresis is
     * overcome. The same logic applies to the SOC low limit, except that after the ramp down is complete,
     * discharging is blocked until the hysteresis is overcome.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue socHighLimitHysteresis = 2;</code>
     */
    public Builder setSocHighLimitHysteresis(
        com.google.protobuf.FloatValue.Builder builderForValue) {
      if (socHighLimitHysteresisBuilder_ == null) {
        socHighLimitHysteresis_ = builderForValue.build();
      } else {
        socHighLimitHysteresisBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/1%  These limits define the operational range of the battery. If a lineup reaches the SOC
     * high limit, the inverter’s output is reduced to 0. Charging is then blocked until the hysteresis is
     * overcome. The same logic applies to the SOC low limit, except that after the ramp down is complete,
     * discharging is blocked until the hysteresis is overcome.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue socHighLimitHysteresis = 2;</code>
     */
    public Builder mergeSocHighLimitHysteresis(com.google.protobuf.FloatValue value) {
      if (socHighLimitHysteresisBuilder_ == null) {
        if (((bitField0_ & 0x00000002) != 0) &&
          socHighLimitHysteresis_ != null &&
          socHighLimitHysteresis_ != com.google.protobuf.FloatValue.getDefaultInstance()) {
          getSocHighLimitHysteresisBuilder().mergeFrom(value);
        } else {
          socHighLimitHysteresis_ = value;
        }
      } else {
        socHighLimitHysteresisBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/1%  These limits define the operational range of the battery. If a lineup reaches the SOC
     * high limit, the inverter’s output is reduced to 0. Charging is then blocked until the hysteresis is
     * overcome. The same logic applies to the SOC low limit, except that after the ramp down is complete,
     * discharging is blocked until the hysteresis is overcome.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue socHighLimitHysteresis = 2;</code>
     */
    public Builder clearSocHighLimitHysteresis() {
      bitField0_ = (bitField0_ & ~0x00000002);
      socHighLimitHysteresis_ = null;
      if (socHighLimitHysteresisBuilder_ != null) {
        socHighLimitHysteresisBuilder_.dispose();
        socHighLimitHysteresisBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/1%  These limits define the operational range of the battery. If a lineup reaches the SOC
     * high limit, the inverter’s output is reduced to 0. Charging is then blocked until the hysteresis is
     * overcome. The same logic applies to the SOC low limit, except that after the ramp down is complete,
     * discharging is blocked until the hysteresis is overcome.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue socHighLimitHysteresis = 2;</code>
     */
    public com.google.protobuf.FloatValue.Builder getSocHighLimitHysteresisBuilder() {
      bitField0_ |= 0x00000002;
      onChanged();
      return getSocHighLimitHysteresisFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * uint/1%  These limits define the operational range of the battery. If a lineup reaches the SOC
     * high limit, the inverter’s output is reduced to 0. Charging is then blocked until the hysteresis is
     * overcome. The same logic applies to the SOC low limit, except that after the ramp down is complete,
     * discharging is blocked until the hysteresis is overcome.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue socHighLimitHysteresis = 2;</code>
     */
    public com.google.protobuf.FloatValueOrBuilder getSocHighLimitHysteresisOrBuilder() {
      if (socHighLimitHysteresisBuilder_ != null) {
        return socHighLimitHysteresisBuilder_.getMessageOrBuilder();
      } else {
        return socHighLimitHysteresis_ == null ?
            com.google.protobuf.FloatValue.getDefaultInstance() : socHighLimitHysteresis_;
      }
    }
    /**
     * <pre>
     * uint/1%  These limits define the operational range of the battery. If a lineup reaches the SOC
     * high limit, the inverter’s output is reduced to 0. Charging is then blocked until the hysteresis is
     * overcome. The same logic applies to the SOC low limit, except that after the ramp down is complete,
     * discharging is blocked until the hysteresis is overcome.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue socHighLimitHysteresis = 2;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder> 
        getSocHighLimitHysteresisFieldBuilder() {
      if (socHighLimitHysteresisBuilder_ == null) {
        socHighLimitHysteresisBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder>(
                getSocHighLimitHysteresis(),
                getParentForChildren(),
                isClean());
        socHighLimitHysteresis_ = null;
      }
      return socHighLimitHysteresisBuilder_;
    }

    private com.google.protobuf.BoolValue socLimitCtl_;
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.BoolValue, com.google.protobuf.BoolValue.Builder, com.google.protobuf.BoolValueOrBuilder> socLimitCtlBuilder_;
    /**
     * <pre>
     * Control value (TRUE or FALSE)
     * </pre>
     *
     * <code>.google.protobuf.BoolValue socLimitCtl = 3;</code>
     * @return Whether the socLimitCtl field is set.
     */
    public boolean hasSocLimitCtl() {
      return ((bitField0_ & 0x00000004) != 0);
    }
    /**
     * <pre>
     * Control value (TRUE or FALSE)
     * </pre>
     *
     * <code>.google.protobuf.BoolValue socLimitCtl = 3;</code>
     * @return The socLimitCtl.
     */
    public com.google.protobuf.BoolValue getSocLimitCtl() {
      if (socLimitCtlBuilder_ == null) {
        return socLimitCtl_ == null ? com.google.protobuf.BoolValue.getDefaultInstance() : socLimitCtl_;
      } else {
        return socLimitCtlBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * Control value (TRUE or FALSE)
     * </pre>
     *
     * <code>.google.protobuf.BoolValue socLimitCtl = 3;</code>
     */
    public Builder setSocLimitCtl(com.google.protobuf.BoolValue value) {
      if (socLimitCtlBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        socLimitCtl_ = value;
      } else {
        socLimitCtlBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Control value (TRUE or FALSE)
     * </pre>
     *
     * <code>.google.protobuf.BoolValue socLimitCtl = 3;</code>
     */
    public Builder setSocLimitCtl(
        com.google.protobuf.BoolValue.Builder builderForValue) {
      if (socLimitCtlBuilder_ == null) {
        socLimitCtl_ = builderForValue.build();
      } else {
        socLimitCtlBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Control value (TRUE or FALSE)
     * </pre>
     *
     * <code>.google.protobuf.BoolValue socLimitCtl = 3;</code>
     */
    public Builder mergeSocLimitCtl(com.google.protobuf.BoolValue value) {
      if (socLimitCtlBuilder_ == null) {
        if (((bitField0_ & 0x00000004) != 0) &&
          socLimitCtl_ != null &&
          socLimitCtl_ != com.google.protobuf.BoolValue.getDefaultInstance()) {
          getSocLimitCtlBuilder().mergeFrom(value);
        } else {
          socLimitCtl_ = value;
        }
      } else {
        socLimitCtlBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Control value (TRUE or FALSE)
     * </pre>
     *
     * <code>.google.protobuf.BoolValue socLimitCtl = 3;</code>
     */
    public Builder clearSocLimitCtl() {
      bitField0_ = (bitField0_ & ~0x00000004);
      socLimitCtl_ = null;
      if (socLimitCtlBuilder_ != null) {
        socLimitCtlBuilder_.dispose();
        socLimitCtlBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Control value (TRUE or FALSE)
     * </pre>
     *
     * <code>.google.protobuf.BoolValue socLimitCtl = 3;</code>
     */
    public com.google.protobuf.BoolValue.Builder getSocLimitCtlBuilder() {
      bitField0_ |= 0x00000004;
      onChanged();
      return getSocLimitCtlFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * Control value (TRUE or FALSE)
     * </pre>
     *
     * <code>.google.protobuf.BoolValue socLimitCtl = 3;</code>
     */
    public com.google.protobuf.BoolValueOrBuilder getSocLimitCtlOrBuilder() {
      if (socLimitCtlBuilder_ != null) {
        return socLimitCtlBuilder_.getMessageOrBuilder();
      } else {
        return socLimitCtl_ == null ?
            com.google.protobuf.BoolValue.getDefaultInstance() : socLimitCtl_;
      }
    }
    /**
     * <pre>
     * Control value (TRUE or FALSE)
     * </pre>
     *
     * <code>.google.protobuf.BoolValue socLimitCtl = 3;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.BoolValue, com.google.protobuf.BoolValue.Builder, com.google.protobuf.BoolValueOrBuilder> 
        getSocLimitCtlFieldBuilder() {
      if (socLimitCtlBuilder_ == null) {
        socLimitCtlBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            com.google.protobuf.BoolValue, com.google.protobuf.BoolValue.Builder, com.google.protobuf.BoolValueOrBuilder>(
                getSocLimitCtl(),
                getParentForChildren(),
                isClean());
        socLimitCtl_ = null;
      }
      return socLimitCtlBuilder_;
    }

    private com.google.protobuf.FloatValue socLowLimit_;
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder> socLowLimitBuilder_;
    /**
     * <pre>
     * uint/1%  These limits define the operational range of the battery. If a lineup reaches the SOC
     * high limit, the inverter’s output is reduced to 0. Charging is then blocked until the hysteresis is
     * overcome. The same logic applies to the SOC low limit, except that after the ramp down is complete,
     * discharging is blocked until the hysteresis is overcome.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue socLowLimit = 4;</code>
     * @return Whether the socLowLimit field is set.
     */
    public boolean hasSocLowLimit() {
      return ((bitField0_ & 0x00000008) != 0);
    }
    /**
     * <pre>
     * uint/1%  These limits define the operational range of the battery. If a lineup reaches the SOC
     * high limit, the inverter’s output is reduced to 0. Charging is then blocked until the hysteresis is
     * overcome. The same logic applies to the SOC low limit, except that after the ramp down is complete,
     * discharging is blocked until the hysteresis is overcome.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue socLowLimit = 4;</code>
     * @return The socLowLimit.
     */
    public com.google.protobuf.FloatValue getSocLowLimit() {
      if (socLowLimitBuilder_ == null) {
        return socLowLimit_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : socLowLimit_;
      } else {
        return socLowLimitBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * uint/1%  These limits define the operational range of the battery. If a lineup reaches the SOC
     * high limit, the inverter’s output is reduced to 0. Charging is then blocked until the hysteresis is
     * overcome. The same logic applies to the SOC low limit, except that after the ramp down is complete,
     * discharging is blocked until the hysteresis is overcome.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue socLowLimit = 4;</code>
     */
    public Builder setSocLowLimit(com.google.protobuf.FloatValue value) {
      if (socLowLimitBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        socLowLimit_ = value;
      } else {
        socLowLimitBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000008;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/1%  These limits define the operational range of the battery. If a lineup reaches the SOC
     * high limit, the inverter’s output is reduced to 0. Charging is then blocked until the hysteresis is
     * overcome. The same logic applies to the SOC low limit, except that after the ramp down is complete,
     * discharging is blocked until the hysteresis is overcome.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue socLowLimit = 4;</code>
     */
    public Builder setSocLowLimit(
        com.google.protobuf.FloatValue.Builder builderForValue) {
      if (socLowLimitBuilder_ == null) {
        socLowLimit_ = builderForValue.build();
      } else {
        socLowLimitBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000008;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/1%  These limits define the operational range of the battery. If a lineup reaches the SOC
     * high limit, the inverter’s output is reduced to 0. Charging is then blocked until the hysteresis is
     * overcome. The same logic applies to the SOC low limit, except that after the ramp down is complete,
     * discharging is blocked until the hysteresis is overcome.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue socLowLimit = 4;</code>
     */
    public Builder mergeSocLowLimit(com.google.protobuf.FloatValue value) {
      if (socLowLimitBuilder_ == null) {
        if (((bitField0_ & 0x00000008) != 0) &&
          socLowLimit_ != null &&
          socLowLimit_ != com.google.protobuf.FloatValue.getDefaultInstance()) {
          getSocLowLimitBuilder().mergeFrom(value);
        } else {
          socLowLimit_ = value;
        }
      } else {
        socLowLimitBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000008;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/1%  These limits define the operational range of the battery. If a lineup reaches the SOC
     * high limit, the inverter’s output is reduced to 0. Charging is then blocked until the hysteresis is
     * overcome. The same logic applies to the SOC low limit, except that after the ramp down is complete,
     * discharging is blocked until the hysteresis is overcome.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue socLowLimit = 4;</code>
     */
    public Builder clearSocLowLimit() {
      bitField0_ = (bitField0_ & ~0x00000008);
      socLowLimit_ = null;
      if (socLowLimitBuilder_ != null) {
        socLowLimitBuilder_.dispose();
        socLowLimitBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/1%  These limits define the operational range of the battery. If a lineup reaches the SOC
     * high limit, the inverter’s output is reduced to 0. Charging is then blocked until the hysteresis is
     * overcome. The same logic applies to the SOC low limit, except that after the ramp down is complete,
     * discharging is blocked until the hysteresis is overcome.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue socLowLimit = 4;</code>
     */
    public com.google.protobuf.FloatValue.Builder getSocLowLimitBuilder() {
      bitField0_ |= 0x00000008;
      onChanged();
      return getSocLowLimitFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * uint/1%  These limits define the operational range of the battery. If a lineup reaches the SOC
     * high limit, the inverter’s output is reduced to 0. Charging is then blocked until the hysteresis is
     * overcome. The same logic applies to the SOC low limit, except that after the ramp down is complete,
     * discharging is blocked until the hysteresis is overcome.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue socLowLimit = 4;</code>
     */
    public com.google.protobuf.FloatValueOrBuilder getSocLowLimitOrBuilder() {
      if (socLowLimitBuilder_ != null) {
        return socLowLimitBuilder_.getMessageOrBuilder();
      } else {
        return socLowLimit_ == null ?
            com.google.protobuf.FloatValue.getDefaultInstance() : socLowLimit_;
      }
    }
    /**
     * <pre>
     * uint/1%  These limits define the operational range of the battery. If a lineup reaches the SOC
     * high limit, the inverter’s output is reduced to 0. Charging is then blocked until the hysteresis is
     * overcome. The same logic applies to the SOC low limit, except that after the ramp down is complete,
     * discharging is blocked until the hysteresis is overcome.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue socLowLimit = 4;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder> 
        getSocLowLimitFieldBuilder() {
      if (socLowLimitBuilder_ == null) {
        socLowLimitBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder>(
                getSocLowLimit(),
                getParentForChildren(),
                isClean());
        socLowLimit_ = null;
      }
      return socLowLimitBuilder_;
    }

    private com.google.protobuf.FloatValue socLowLimitHysteresis_;
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder> socLowLimitHysteresisBuilder_;
    /**
     * <pre>
     * uint/1%  These hysteresis define the release conditions for the block charge or discharge
     * initiated by the SOC limits.For example, assume a SOC low limit of 10% and a SOC low limit
     * hysteresis of 2% and that discharging is blocked because the batteries SOC reached the SOC low
     * limit, discharging will only be allowed again after the battery’s SOC reaches 13%.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue socLowLimitHysteresis = 5;</code>
     * @return Whether the socLowLimitHysteresis field is set.
     */
    public boolean hasSocLowLimitHysteresis() {
      return ((bitField0_ & 0x00000010) != 0);
    }
    /**
     * <pre>
     * uint/1%  These hysteresis define the release conditions for the block charge or discharge
     * initiated by the SOC limits.For example, assume a SOC low limit of 10% and a SOC low limit
     * hysteresis of 2% and that discharging is blocked because the batteries SOC reached the SOC low
     * limit, discharging will only be allowed again after the battery’s SOC reaches 13%.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue socLowLimitHysteresis = 5;</code>
     * @return The socLowLimitHysteresis.
     */
    public com.google.protobuf.FloatValue getSocLowLimitHysteresis() {
      if (socLowLimitHysteresisBuilder_ == null) {
        return socLowLimitHysteresis_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : socLowLimitHysteresis_;
      } else {
        return socLowLimitHysteresisBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * uint/1%  These hysteresis define the release conditions for the block charge or discharge
     * initiated by the SOC limits.For example, assume a SOC low limit of 10% and a SOC low limit
     * hysteresis of 2% and that discharging is blocked because the batteries SOC reached the SOC low
     * limit, discharging will only be allowed again after the battery’s SOC reaches 13%.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue socLowLimitHysteresis = 5;</code>
     */
    public Builder setSocLowLimitHysteresis(com.google.protobuf.FloatValue value) {
      if (socLowLimitHysteresisBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        socLowLimitHysteresis_ = value;
      } else {
        socLowLimitHysteresisBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000010;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/1%  These hysteresis define the release conditions for the block charge or discharge
     * initiated by the SOC limits.For example, assume a SOC low limit of 10% and a SOC low limit
     * hysteresis of 2% and that discharging is blocked because the batteries SOC reached the SOC low
     * limit, discharging will only be allowed again after the battery’s SOC reaches 13%.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue socLowLimitHysteresis = 5;</code>
     */
    public Builder setSocLowLimitHysteresis(
        com.google.protobuf.FloatValue.Builder builderForValue) {
      if (socLowLimitHysteresisBuilder_ == null) {
        socLowLimitHysteresis_ = builderForValue.build();
      } else {
        socLowLimitHysteresisBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000010;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/1%  These hysteresis define the release conditions for the block charge or discharge
     * initiated by the SOC limits.For example, assume a SOC low limit of 10% and a SOC low limit
     * hysteresis of 2% and that discharging is blocked because the batteries SOC reached the SOC low
     * limit, discharging will only be allowed again after the battery’s SOC reaches 13%.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue socLowLimitHysteresis = 5;</code>
     */
    public Builder mergeSocLowLimitHysteresis(com.google.protobuf.FloatValue value) {
      if (socLowLimitHysteresisBuilder_ == null) {
        if (((bitField0_ & 0x00000010) != 0) &&
          socLowLimitHysteresis_ != null &&
          socLowLimitHysteresis_ != com.google.protobuf.FloatValue.getDefaultInstance()) {
          getSocLowLimitHysteresisBuilder().mergeFrom(value);
        } else {
          socLowLimitHysteresis_ = value;
        }
      } else {
        socLowLimitHysteresisBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000010;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/1%  These hysteresis define the release conditions for the block charge or discharge
     * initiated by the SOC limits.For example, assume a SOC low limit of 10% and a SOC low limit
     * hysteresis of 2% and that discharging is blocked because the batteries SOC reached the SOC low
     * limit, discharging will only be allowed again after the battery’s SOC reaches 13%.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue socLowLimitHysteresis = 5;</code>
     */
    public Builder clearSocLowLimitHysteresis() {
      bitField0_ = (bitField0_ & ~0x00000010);
      socLowLimitHysteresis_ = null;
      if (socLowLimitHysteresisBuilder_ != null) {
        socLowLimitHysteresisBuilder_.dispose();
        socLowLimitHysteresisBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/1%  These hysteresis define the release conditions for the block charge or discharge
     * initiated by the SOC limits.For example, assume a SOC low limit of 10% and a SOC low limit
     * hysteresis of 2% and that discharging is blocked because the batteries SOC reached the SOC low
     * limit, discharging will only be allowed again after the battery’s SOC reaches 13%.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue socLowLimitHysteresis = 5;</code>
     */
    public com.google.protobuf.FloatValue.Builder getSocLowLimitHysteresisBuilder() {
      bitField0_ |= 0x00000010;
      onChanged();
      return getSocLowLimitHysteresisFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * uint/1%  These hysteresis define the release conditions for the block charge or discharge
     * initiated by the SOC limits.For example, assume a SOC low limit of 10% and a SOC low limit
     * hysteresis of 2% and that discharging is blocked because the batteries SOC reached the SOC low
     * limit, discharging will only be allowed again after the battery’s SOC reaches 13%.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue socLowLimitHysteresis = 5;</code>
     */
    public com.google.protobuf.FloatValueOrBuilder getSocLowLimitHysteresisOrBuilder() {
      if (socLowLimitHysteresisBuilder_ != null) {
        return socLowLimitHysteresisBuilder_.getMessageOrBuilder();
      } else {
        return socLowLimitHysteresis_ == null ?
            com.google.protobuf.FloatValue.getDefaultInstance() : socLowLimitHysteresis_;
      }
    }
    /**
     * <pre>
     * uint/1%  These hysteresis define the release conditions for the block charge or discharge
     * initiated by the SOC limits.For example, assume a SOC low limit of 10% and a SOC low limit
     * hysteresis of 2% and that discharging is blocked because the batteries SOC reached the SOC low
     * limit, discharging will only be allowed again after the battery’s SOC reaches 13%.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue socLowLimitHysteresis = 5;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder> 
        getSocLowLimitHysteresisFieldBuilder() {
      if (socLowLimitHysteresisBuilder_ == null) {
        socLowLimitHysteresisBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder>(
                getSocLowLimitHysteresis(),
                getParentForChildren(),
                isClean());
        socLowLimitHysteresis_ = null;
      }
      return socLowLimitHysteresisBuilder_;
    }
    @java.lang.Override
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:essmodule.SocLimit)
  }

  // @@protoc_insertion_point(class_scope:essmodule.SocLimit)
  private static final openfmb.essmodule.SocLimit DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new openfmb.essmodule.SocLimit();
  }

  public static openfmb.essmodule.SocLimit getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<SocLimit>
      PARSER = new com.google.protobuf.AbstractParser<SocLimit>() {
    @java.lang.Override
    public SocLimit parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      Builder builder = newBuilder();
      try {
        builder.mergeFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(builder.buildPartial());
      } catch (com.google.protobuf.UninitializedMessageException e) {
        throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(e)
            .setUnfinishedMessage(builder.buildPartial());
      }
      return builder.buildPartial();
    }
  };

  public static com.google.protobuf.Parser<SocLimit> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<SocLimit> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public openfmb.essmodule.SocLimit getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

